// A TrisCell is a single cell on the Tris field.
// A TrisCell is constructed with a pointer to its parent object,
// so it can draw itself.
class TrisCell {
  int x, y, w, h;
  wxCanvas *parent;
  wxBrush *brush;   // Pointer to brush with which to draw this cell
  Bool used;
public:
  TrisCell(TrisField *p);
  void Clone(TrisCell *);
  Bool Used(void);
  void Draw(void);
  void Size(int X, int Y, int W, int H);
  void SetBrush(wxBrush *b);
  wxBrush *GetBrush(void);
  void SetUsed(Bool tf);
};
